/* urlbar.c generated by valac 0.52.4, the Vala compiler
 * generated from urlbar.vala, do not modify */

/*
 Copyright (C) 2018 Christian Dywan <christian@twotoats.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include "midori-core.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <ui/gcr-ui.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include "webkit2/webkit2.h"
#include <gcr/gcr-base.h>
#include <libsoup/soup.h>

enum  {
	MIDORI_URLBAR_0_PROPERTY,
	MIDORI_URLBAR_KEY_PROPERTY,
	MIDORI_URLBAR_REGEX_PROPERTY,
	MIDORI_URLBAR_LOCATION_PROPERTY,
	MIDORI_URLBAR_URI_PROPERTY,
	MIDORI_URLBAR_SECURE_PROPERTY,
	MIDORI_URLBAR_BLANK_PROPERTY,
	MIDORI_URLBAR_NUM_PROPERTIES
};
static GParamSpec* midori_urlbar_properties[MIDORI_URLBAR_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block23Data Block23Data;
#define _g_byte_array_unref0(var) ((var == NULL) ? NULL : (var = (g_byte_array_unref (var), NULL)))
#define __vala_SoupURI_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupURI_free (var), NULL)))

struct _MidoriUrlbarPrivate {
	gchar* _key;
	GRegex* _regex;
	gchar* _location;
	gchar* _uri;
	gboolean _secure;
	GtkPopover* suggestions;
	GtkListBox* listbox;
	GtkListBoxRow* _selected_row;
	GtkPopover* security;
	GtkBox* security_box;
	GtkButton* trust;
	GtkLabel* security_status;
	GcrCertificateWidget* details;
};

struct _Block23Data {
	int _ref_count_;
	MidoriUrlbar* self;
	gchar* text;
};

static gint MidoriUrlbar_private_offset;
static gpointer midori_urlbar_parent_class = NULL;

static gboolean midori_urlbar_real_key_press_event (GtkWidget* base,
                                             GdkEventKey* event);
static GtkListBoxRow* midori_urlbar_get_selected_row (MidoriUrlbar* self);
static GVariant* _variant_new13 (const gchar* value);
static void midori_urlbar_complete (MidoriUrlbar* self);
gboolean midori_urlbar_get_blank (MidoriUrlbar* self);
static void midori_urlbar_update_key (MidoriUrlbar* self,
                               const gchar* text);
static gchar* midori_urlbar_magic_uri (MidoriUrlbar* self,
                                const gchar* text);
static gboolean midori_urlbar_is_external (MidoriUrlbar* self,
                                    const gchar* uri);
static gboolean midori_urlbar_is_location (MidoriUrlbar* self,
                                    const gchar* uri);
static gboolean midori_urlbar_is_ip_address (MidoriUrlbar* self,
                                      const gchar* uri);
static gboolean midori_urlbar_real_focus_out_event (GtkWidget* base,
                                             GdkEventFocus* event);
static void midori_urlbar_resize (MidoriUrlbar* self,
                           GtkAllocation* allocation);
static GtkWidget* _midori_urlbar_create_row_gtk_list_box_create_widget_func (GObject* item,
                                                                      gpointer self);
static void midori_urlbar_real_populate_popup (GtkEntry* base,
                                        GtkMenu* menu);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void __lambda30_ (Block23Data* _data23_);
static void ___lambda30__gtk_menu_item_activate (GtkMenuItem* _sender,
                                          gpointer self);
static void midori_urlbar_update_icon (MidoriUrlbar* self);
static void midori_urlbar_icon_pressed (MidoriUrlbar* self,
                                 GtkEntryIconPosition position,
                                 GdkEvent* event);
GTlsCertificate* midori_tab_get_tls (MidoriTab* self);
static gboolean ___lambda31_ (MidoriUrlbar* self,
                       GdkEventButton* event);
static gboolean ____lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self);
static void ___lambda32_ (MidoriUrlbar* self);
static void _vala_SoupURI_free (SoupURI* self);
static void ____lambda32__gtk_button_clicked (GtkButton* _sender,
                                       gpointer self);
static void midori_urlbar_set_selected_row (MidoriUrlbar* self,
                                     GtkListBoxRow* value);
static GObject * midori_urlbar_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static void _midori_urlbar_resize_gtk_widget_size_allocate (GtkWidget* _sender,
                                                     GtkAllocation* allocation,
                                                     gpointer self);
static void _midori_urlbar___lambda33_ (MidoriUrlbar* self);
static void __midori_urlbar___lambda33__gtk_widget_hide (GtkWidget* _sender,
                                                  gpointer self);
static void _midori_urlbar___lambda34_ (MidoriUrlbar* self,
                                 GtkListBoxRow* row);
static void __midori_urlbar___lambda34__gtk_list_box_row_selected (GtkListBox* _sender,
                                                            GtkListBoxRow* row,
                                                            gpointer self);
static void _midori_urlbar___lambda35_ (MidoriUrlbar* self,
                                 GtkListBoxRow* row);
static void __midori_urlbar___lambda35__gtk_list_box_row_activated (GtkListBox* _sender,
                                                             GtkListBoxRow* row,
                                                             gpointer self);
static void _midori_urlbar___lambda36_ (MidoriUrlbar* self,
                                 const gchar* new_text,
                                 gint new_position,
                                 gint* position);
static void __midori_urlbar___lambda36__gtk_editable_insert_text (GtkEditable* _sender,
                                                           const gchar* new_text,
                                                           gint new_text_length,
                                                           gint* position,
                                                           gpointer self);
static void _midori_urlbar___lambda37_ (MidoriUrlbar* self,
                                 gint start_pos,
                                 gint end_pos);
static void __midori_urlbar___lambda37__gtk_editable_delete_text (GtkEditable* _sender,
                                                           gint start_pos,
                                                           gint end_pos,
                                                           gpointer self);
static void _midori_urlbar_icon_pressed_gtk_entry_icon_press (GtkEntry* _sender,
                                                       GtkEntryIconPosition icon_pos,
                                                       GdkEvent* event,
                                                       gpointer self);
static void midori_urlbar_finalize (GObject * obj);
static GType midori_urlbar_get_type_once (void);
static void _vala_midori_urlbar_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_midori_urlbar_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
midori_urlbar_get_instance_private (MidoriUrlbar* self)
{
	return G_STRUCT_MEMBER_P (self, MidoriUrlbar_private_offset);
}

GtkWidget*
midori_urlbar_create_row (MidoriUrlbar* self,
                          GObject* item)
{
	MidoriSuggestionRow* suggestion = NULL;
	MidoriSuggestionRow* _tmp0_;
	const gchar* _tmp1_;
	GRegex* _tmp2_;
	const gchar* _tmp3_;
	GtkWidget* result = NULL;
#line 76 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = midori_suggestion_row_new (G_TYPE_CHECK_INSTANCE_CAST (item, MIDORI_TYPE_DATABASE_ITEM, MidoriDatabaseItem));
#line 76 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_ref_sink (_tmp0_);
#line 76 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	suggestion = _tmp0_;
#line 77 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = self->priv->_key;
#line 77 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_suggestion_row_set_key (suggestion, _tmp1_);
#line 78 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_bind_property_with_closures ((GObject*) self, "key", (GObject*) suggestion, "key", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 79 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = self->priv->_regex;
#line 79 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_suggestion_row_set_regex (suggestion, _tmp2_);
#line 80 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_bind_property_with_closures ((GObject*) self, "regex", (GObject*) suggestion, "regex", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 81 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp3_ = self->priv->_location;
#line 81 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_suggestion_row_set_location (suggestion, _tmp3_);
#line 82 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_bind_property_with_closures ((GObject*) self, "location", (GObject*) suggestion, "location", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 83 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = (GtkWidget*) suggestion;
#line 83 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 223 "urlbar.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 110 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return self ? g_object_ref (self) : NULL;
#line 231 "urlbar.c"
}

static GVariant*
_variant_new13 (const gchar* value)
{
#line 141 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 239 "urlbar.c"
}

static gboolean
midori_urlbar_real_key_press_event (GtkWidget* base,
                                    GdkEventKey* event)
{
	MidoriUrlbar * self;
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gunichar character = 0U;
	gboolean _tmp54_ = FALSE;
	gboolean result = FALSE;
#line 86 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self = (MidoriUrlbar*) base;
#line 88 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->suggestions;
#line 88 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 88 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = _tmp1_;
#line 88 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp2_) {
#line 263 "urlbar.c"
		gboolean has_shift = FALSE;
		GdkModifierType _tmp3_;
		GtkListBox* _tmp28_;
		gboolean _tmp29_ = FALSE;
#line 89 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = event->state;
#line 89 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		has_shift = (_tmp3_ & GDK_SHIFT_MASK) != 0;
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		switch (event->keyval) {
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_Tab:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_ISO_Left_Tab:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_Down:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_KP_Down:
#line 282 "urlbar.c"
			{
				gint _tmp4_ = 0;
				GtkListBox* _tmp5_;
#line 96 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				if (has_shift) {
#line 96 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp4_ = -1;
#line 290 "urlbar.c"
				} else {
#line 96 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp4_ = 1;
#line 294 "urlbar.c"
				}
#line 95 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp5_ = self->priv->listbox;
#line 95 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				g_signal_emit_by_name (_tmp5_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINES, _tmp4_);
#line 97 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = TRUE;
#line 97 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 304 "urlbar.c"
			}
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_Up:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_KP_Up:
#line 310 "urlbar.c"
			{
				GtkListBox* _tmp6_;
#line 100 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp6_ = self->priv->listbox;
#line 100 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				g_signal_emit_by_name (_tmp6_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINES, -1);
#line 101 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = TRUE;
#line 101 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 321 "urlbar.c"
			}
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_Left:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_KP_Left:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_Right:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_KP_Right:
#line 331 "urlbar.c"
			{
#line 106 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				midori_urlbar_popdown (self);
#line 107 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = GTK_WIDGET_CLASS (midori_urlbar_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), event);
#line 107 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 339 "urlbar.c"
			}
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_Delete:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_KP_Delete:
#line 345 "urlbar.c"
			{
				MidoriSuggestionRow* suggestion_row = NULL;
				GtkListBoxRow* _tmp7_;
				MidoriSuggestionRow* _tmp8_;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
				MidoriSuggestionRow* _tmp11_;
#line 110 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp7_ = self->priv->_selected_row;
#line 110 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, MIDORI_TYPE_SUGGESTION_ROW, MidoriSuggestionRow));
#line 110 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				suggestion_row = _tmp8_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp11_ = suggestion_row;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				if (_tmp11_ != NULL) {
#line 363 "urlbar.c"
					MidoriSuggestionRow* _tmp12_;
					MidoriDatabaseItem* _tmp13_;
					MidoriDatabaseItem* _tmp14_;
					MidoriDatabase* _tmp15_;
					MidoriDatabase* _tmp16_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp12_ = suggestion_row;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp13_ = midori_suggestion_row_get_item (_tmp12_);
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp14_ = _tmp13_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp15_ = midori_database_item_get_database (_tmp14_);
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp16_ = _tmp15_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp10_ = _tmp16_ != NULL;
#line 381 "urlbar.c"
				} else {
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp10_ = FALSE;
#line 385 "urlbar.c"
				}
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				if (_tmp10_) {
#line 389 "urlbar.c"
					MidoriSuggestionRow* _tmp17_;
					MidoriDatabaseItem* _tmp18_;
					MidoriDatabaseItem* _tmp19_;
					MidoriDatabase* _tmp20_;
					MidoriDatabase* _tmp21_;
					gboolean _tmp22_;
					gboolean _tmp23_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp17_ = suggestion_row;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp18_ = midori_suggestion_row_get_item (_tmp17_);
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp19_ = _tmp18_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp20_ = midori_database_item_get_database (_tmp19_);
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp21_ = _tmp20_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp22_ = midori_database_get_readonly (_tmp21_);
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp23_ = _tmp22_;
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp9_ = !_tmp23_;
#line 413 "urlbar.c"
				} else {
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp9_ = FALSE;
#line 417 "urlbar.c"
				}
#line 111 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				if (_tmp9_) {
#line 421 "urlbar.c"
					GtkListBox* _tmp24_;
					MidoriSuggestionRow* _tmp25_;
					MidoriDatabaseItem* _tmp26_;
					MidoriDatabaseItem* _tmp27_;
#line 112 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp24_ = self->priv->listbox;
#line 112 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					g_signal_emit_by_name (_tmp24_, "move-cursor", GTK_MOVEMENT_DISPLAY_LINES, -1);
#line 113 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp25_ = suggestion_row;
#line 113 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp26_ = midori_suggestion_row_get_item (_tmp25_);
#line 113 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp27_ = _tmp26_;
#line 113 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					midori_database_item_delete (_tmp27_, NULL, NULL);
#line 114 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					result = TRUE;
#line 114 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_g_object_unref0 (suggestion_row);
#line 114 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					return result;
#line 444 "urlbar.c"
				}
#line 116 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = GTK_WIDGET_CLASS (midori_urlbar_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), event);
#line 116 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_g_object_unref0 (suggestion_row);
#line 116 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 452 "urlbar.c"
			}
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			case GDK_KEY_Escape:
#line 456 "urlbar.c"
			{
#line 118 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				midori_urlbar_popdown (self);
#line 119 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = TRUE;
#line 119 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 464 "urlbar.c"
			}
			default:
#line 90 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			break;
#line 469 "urlbar.c"
		}
#line 122 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp28_ = self->priv->listbox;
#line 122 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_signal_emit_by_name ((GtkWidget*) _tmp28_, "key-press-event", event, &_tmp29_);
#line 122 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		if (!_tmp29_) {
#line 477 "urlbar.c"
			GtkPopover* _tmp30_;
			gboolean _tmp31_ = FALSE;
#line 123 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp30_ = self->priv->suggestions;
#line 123 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			g_signal_emit_by_name ((GtkWidget*) _tmp30_, "key-press-event", event, &_tmp31_);
#line 123 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			if (_tmp31_) {
#line 124 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = TRUE;
#line 124 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 490 "urlbar.c"
			}
		}
	}
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	switch (event->keyval) {
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_Tab:
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_ISO_Left_Tab:
#line 500 "urlbar.c"
		{
#line 132 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			result = FALSE;
#line 132 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			return result;
#line 506 "urlbar.c"
		}
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_ISO_Enter:
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_KP_Enter:
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_Return:
#line 514 "urlbar.c"
		{
			gboolean has_ctrl = FALSE;
			GdkModifierType _tmp32_;
#line 136 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp32_ = event->state;
#line 136 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			has_ctrl = (_tmp32_ & GDK_CONTROL_MASK) != 0;
#line 137 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			if (has_ctrl) {
#line 524 "urlbar.c"
				gboolean has_shift = FALSE;
				GdkModifierType _tmp33_;
#line 138 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				midori_urlbar_popdown (self);
#line 139 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp33_ = event->state;
#line 139 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				has_shift = (_tmp33_ & GDK_SHIFT_MASK) != 0;
#line 140 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				if (has_shift) {
#line 535 "urlbar.c"
					GApplication* _tmp34_;
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					GVariant* _tmp37_;
#line 141 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp34_ = g_application_get_default ();
#line 141 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp35_ = gtk_entry_get_text ((GtkEntry*) self);
#line 141 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp36_ = _tmp35_;
#line 141 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp37_ = _variant_new13 (_tmp36_);
#line 141 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					g_action_group_activate_action ((GActionGroup*) _tmp34_, "win-new", _tmp37_);
#line 141 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_g_variant_unref0 (_tmp37_);
#line 552 "urlbar.c"
				} else {
					MidoriBrowser* browser = NULL;
					GtkWidget* _tmp38_;
					MidoriBrowser* _tmp39_;
					MidoriBrowser* _tmp40_;
					MidoriBrowser* _tmp41_;
					WebKitWebContext* _tmp42_;
					WebKitWebContext* _tmp43_;
					const gchar* _tmp44_;
					const gchar* _tmp45_;
					MidoriTab* _tmp46_;
					MidoriTab* _tmp47_;
#line 143 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp38_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 143 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp39_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, MIDORI_TYPE_BROWSER, MidoriBrowser));
#line 143 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					browser = _tmp39_;
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp40_ = browser;
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp41_ = browser;
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp42_ = midori_browser_get_web_context (_tmp41_);
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp43_ = _tmp42_;
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp44_ = gtk_entry_get_text ((GtkEntry*) self);
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp45_ = _tmp44_;
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp46_ = midori_tab_new (NULL, _tmp43_, _tmp45_, NULL);
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					g_object_ref_sink (_tmp46_);
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp47_ = _tmp46_;
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					midori_browser_add (_tmp40_, _tmp47_);
#line 144 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_g_object_unref0 (_tmp47_);
#line 140 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_g_object_unref0 (browser);
#line 595 "urlbar.c"
				}
			} else {
				GtkListBox* _tmp48_;
#line 147 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp48_ = self->priv->listbox;
#line 147 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				g_signal_emit_by_name (_tmp48_, "activate-cursor-row");
#line 603 "urlbar.c"
			}
#line 149 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			result = TRUE;
#line 149 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			return result;
#line 609 "urlbar.c"
		}
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_Down:
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_KP_Down:
#line 615 "urlbar.c"
		{
#line 152 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			midori_urlbar_complete (self);
#line 153 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			result = TRUE;
#line 153 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			return result;
#line 623 "urlbar.c"
		}
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case GDK_KEY_Escape:
#line 627 "urlbar.c"
		{
			const gchar* _tmp49_ = NULL;
			gboolean _tmp50_;
			gboolean _tmp51_;
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp50_ = midori_urlbar_get_blank (self);
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp51_ = _tmp50_;
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			if (_tmp51_) {
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp49_ = "";
#line 640 "urlbar.c"
			} else {
				const gchar* _tmp52_;
				const gchar* _tmp53_;
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp52_ = midori_urlbar_get_uri (self);
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp53_ = _tmp52_;
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp49_ = _tmp53_;
#line 650 "urlbar.c"
			}
#line 155 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			gtk_entry_set_text ((GtkEntry*) self, _tmp49_);
#line 156 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			gtk_editable_set_position ((GtkEditable*) self, -1);
#line 158 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			result = FALSE;
#line 158 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			return result;
#line 660 "urlbar.c"
		}
		default:
#line 129 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 665 "urlbar.c"
	}
#line 162 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	character = (gunichar) gdk_keyval_to_unicode (event->keyval);
#line 163 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (character != ((gunichar) 0)) {
#line 163 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp54_ = event->is_modifier == ((guint) 0);
#line 673 "urlbar.c"
	} else {
#line 163 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp54_ = FALSE;
#line 677 "urlbar.c"
	}
#line 163 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp54_) {
#line 164 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_complete (self);
#line 683 "urlbar.c"
	}
#line 166 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = GTK_WIDGET_CLASS (midori_urlbar_parent_class)->key_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), event);
#line 166 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 689 "urlbar.c"
}

static void
midori_urlbar_update_key (MidoriUrlbar* self,
                          const gchar* text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 170 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = midori_urlbar_magic_uri (self, text);
#line 170 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = _tmp0_;
#line 170 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_set_location (self, _tmp1_);
#line 170 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_free0 (_tmp1_);
#line 707 "urlbar.c"
	{
		GRegex* _tmp2_ = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GRegex* _tmp8_;
		GRegex* _tmp9_;
#line 172 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_key (self, text);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = self->priv->_key;
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = g_regex_escape_string (_tmp3_, -1);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp5_ = _tmp4_;
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp6_ = g_strdup_printf ("(%s)", _tmp5_);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp7_ = _tmp6_;
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp8_ = g_regex_new (_tmp7_, G_REGEX_CASELESS, 0, &_inner_error0_);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp9_ = _tmp8_;
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_free0 (_tmp7_);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_free0 (_tmp5_);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = _tmp9_;
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 743 "urlbar.c"
				goto __catch0_g_regex_error;
			}
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			g_clear_error (&_inner_error0_);
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			return;
#line 752 "urlbar.c"
		}
#line 173 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_regex (self, _tmp2_);
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_regex_unref0 (_tmp2_);
#line 758 "urlbar.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError* _error_ = NULL;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_error_ = _inner_error0_;
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_inner_error0_ = NULL;
#line 176 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_regex (self, NULL);
#line 177 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp10_ = _error_;
#line 177 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp11_ = _tmp10_->message;
#line 177 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_debug ("urlbar.vala:177: Failed to create regex: %s", _tmp11_);
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_error_free0 (_error_);
#line 780 "urlbar.c"
	}
	__finally0:
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_clear_error (&_inner_error0_);
#line 171 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		return;
#line 791 "urlbar.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 807 "urlbar.c"
}

static gchar*
midori_urlbar_magic_uri (MidoriUrlbar* self,
                         const gchar* text)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 183 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_str_has_prefix (text, " ")) {
#line 183 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = TRUE;
#line 821 "urlbar.c"
	} else {
#line 183 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = g_str_has_suffix (text, " ");
#line 825 "urlbar.c"
	}
#line 183 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp0_) {
#line 184 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		result = NULL;
#line 184 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		return result;
#line 833 "urlbar.c"
	} else {
#line 185 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		if (g_path_is_absolute (text)) {
#line 837 "urlbar.c"
			{
				gchar* _tmp1_ = NULL;
				gchar* _tmp2_;
				gchar* _tmp3_;
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp2_ = g_filename_to_uri (text, NULL, &_inner_error0_);
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp1_ = _tmp2_;
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 850 "urlbar.c"
						goto __catch0_g_convert_error;
					}
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					g_clear_error (&_inner_error0_);
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					return NULL;
#line 859 "urlbar.c"
				}
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp3_ = _tmp1_;
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp1_ = NULL;
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = _tmp3_;
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_g_free0 (_tmp1_);
#line 187 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 871 "urlbar.c"
			}
			goto __finally0;
			__catch0_g_convert_error:
			{
				GError* _error_ = NULL;
				GError* _tmp4_;
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 186 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_error_ = _inner_error0_;
#line 186 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_inner_error0_ = NULL;
#line 189 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp4_ = _error_;
#line 189 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp5_ = _tmp4_->message;
#line 189 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				g_debug ("urlbar.vala:189: Failed to convert URI to filename: %s", _tmp5_);
#line 190 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp6_ = g_strdup (text);
#line 190 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = _tmp6_;
#line 190 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_g_error_free0 (_error_);
#line 190 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 898 "urlbar.c"
			}
			__finally0:
#line 186 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 186 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			g_clear_error (&_inner_error0_);
#line 186 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			return NULL;
#line 907 "urlbar.c"
		} else {
#line 192 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			if (g_file_test (text, G_FILE_TEST_EXISTS | G_FILE_TEST_IS_REGULAR)) {
#line 911 "urlbar.c"
				GFile* _tmp7_;
				GFile* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
#line 193 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp7_ = g_file_new_for_commandline_arg (text);
#line 193 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp8_ = _tmp7_;
#line 193 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp9_ = g_file_get_uri (_tmp8_);
#line 193 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_tmp10_ = _tmp9_;
#line 193 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				_g_object_unref0 (_tmp8_);
#line 193 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				result = _tmp10_;
#line 193 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				return result;
#line 930 "urlbar.c"
			} else {
#line 194 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
				if (midori_urlbar_is_external (self, text)) {
#line 934 "urlbar.c"
					gchar* _tmp11_;
#line 195 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					_tmp11_ = g_strdup (text);
#line 195 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					result = _tmp11_;
#line 195 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					return result;
#line 942 "urlbar.c"
				} else {
#line 196 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
					if (g_str_has_prefix (text, "geo:")) {
#line 946 "urlbar.c"
						gchar* _tmp12_;
#line 198 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
						_tmp12_ = g_strdup (text);
#line 198 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
						result = _tmp12_;
#line 198 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
						return result;
#line 954 "urlbar.c"
					} else {
#line 199 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
						if (midori_urlbar_is_location (self, text)) {
#line 958 "urlbar.c"
							gchar* _tmp13_;
#line 200 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
							_tmp13_ = g_strdup (text);
#line 200 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
							result = _tmp13_;
#line 200 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
							return result;
#line 966 "urlbar.c"
						} else {
#line 201 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
							if (midori_urlbar_is_ip_address (self, text)) {
#line 970 "urlbar.c"
								gchar* _tmp14_;
#line 202 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
								_tmp14_ = g_strconcat ("http://", text, NULL);
#line 202 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
								result = _tmp14_;
#line 202 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
								return result;
#line 978 "urlbar.c"
							} else {
								gboolean _tmp15_ = FALSE;
#line 203 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
								if (g_str_has_prefix (text, "localhost")) {
#line 203 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
									_tmp15_ = TRUE;
#line 985 "urlbar.c"
								} else {
#line 203 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
									_tmp15_ = string_contains (text, ".");
#line 989 "urlbar.c"
								}
#line 203 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
								if (_tmp15_) {
#line 993 "urlbar.c"
									gchar* _tmp16_;
#line 204 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
									_tmp16_ = g_strconcat ("http://", text, NULL);
#line 204 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
									result = _tmp16_;
#line 204 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
									return result;
#line 1001 "urlbar.c"
								} else {
#line 205 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
									if (g_strcmp0 (text, "") == 0) {
#line 1005 "urlbar.c"
										gchar* _tmp17_;
#line 206 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
										_tmp17_ = g_strdup ("about:blank");
#line 206 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
										result = _tmp17_;
#line 206 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
										return result;
#line 1013 "urlbar.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 209 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = NULL;
#line 209 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1027 "urlbar.c"
}

static gboolean
midori_urlbar_is_location (MidoriUrlbar* self,
                           const gchar* uri)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean result = FALSE;
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_str_has_prefix (uri, "about:")) {
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = TRUE;
#line 1043 "urlbar.c"
	} else {
#line 215 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = g_str_has_prefix (uri, "http://");
#line 1047 "urlbar.c"
	}
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp3_) {
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = TRUE;
#line 1053 "urlbar.c"
	} else {
#line 216 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = g_str_has_prefix (uri, "https://");
#line 1057 "urlbar.c"
	}
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp2_) {
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = TRUE;
#line 1063 "urlbar.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 217 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		if (g_str_has_prefix (uri, "data:")) {
#line 217 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp4_ = string_contains (uri, ";");
#line 1070 "urlbar.c"
		} else {
#line 217 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp4_ = FALSE;
#line 1074 "urlbar.c"
		}
#line 217 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = _tmp4_;
#line 1078 "urlbar.c"
	}
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp1_) {
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = TRUE;
#line 1084 "urlbar.c"
	} else {
#line 218 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = g_str_has_prefix (uri, "javascript:");
#line 1088 "urlbar.c"
	}
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp0_;
#line 214 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1094 "urlbar.c"
}

static gboolean
midori_urlbar_is_external (MidoriUrlbar* self,
                           const gchar* uri)
{
	gchar* scheme = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result = FALSE;
#line 222 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_str_has_prefix (uri, "file://")) {
#line 223 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		result = TRUE;
#line 223 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		return result;
#line 1112 "urlbar.c"
	}
#line 225 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = g_uri_parse_scheme (uri);
#line 225 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	scheme = _tmp0_;
#line 226 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = scheme;
#line 226 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp2_ != NULL) {
#line 1122 "urlbar.c"
		const gchar* _tmp3_;
		GAppInfo* _tmp4_;
		GAppInfo* _tmp5_;
#line 227 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = scheme;
#line 227 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = g_app_info_get_default_for_uri_scheme (_tmp3_);
#line 227 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp5_ = _tmp4_;
#line 227 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = _tmp5_ != NULL;
#line 227 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (_tmp5_);
#line 1136 "urlbar.c"
	} else {
#line 226 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = FALSE;
#line 1140 "urlbar.c"
	}
#line 226 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp1_;
#line 226 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_free0 (scheme);
#line 226 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1148 "urlbar.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
#line 1233 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1233 "glib-2.0.vapi"
	result = _tmp0_;
#line 1233 "glib-2.0.vapi"
	return result;
#line 1163 "urlbar.c"
}

static gboolean
midori_urlbar_is_ip_address (MidoriUrlbar* self,
                             const gchar* uri)
{
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean result = FALSE;
#line 235 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (string_contains (uri, "@")) {
#line 1180 "urlbar.c"
		gchar** _tmp0_;
		gchar** _tmp1_;
		gchar** _tmp2_;
		gint _tmp2__length1;
		const gchar* _tmp3_;
		gboolean _tmp4_;
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = _tmp0_ = g_strsplit (uri, "@", 0);
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = _tmp1_;
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2__length1 = _vala_array_length (_tmp0_);
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = _tmp2_[1];
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = midori_urlbar_is_ip_address (self, _tmp3_);
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		result = _tmp4_;
#line 236 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		return result;
#line 1203 "urlbar.c"
	}
#line 238 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (string_get (uri, (glong) 0) != '0') {
#line 238 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp6_ = g_ascii_isdigit (string_get (uri, (glong) 0));
#line 1209 "urlbar.c"
	} else {
#line 238 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp6_ = FALSE;
#line 1213 "urlbar.c"
	}
#line 238 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp6_) {
#line 238 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp5_ = string_contains (uri, ".");
#line 1219 "urlbar.c"
	} else {
#line 238 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp5_ = FALSE;
#line 1223 "urlbar.c"
	}
#line 238 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp5_) {
#line 239 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		result = TRUE;
#line 239 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		return result;
#line 1231 "urlbar.c"
	}
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_ascii_isalnum (string_get (uri, (glong) 0))) {
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp11_ = g_ascii_isalnum (string_get (uri, (glong) 1));
#line 1237 "urlbar.c"
	} else {
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp11_ = FALSE;
#line 1241 "urlbar.c"
	}
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp11_) {
#line 242 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp10_ = g_ascii_isalnum (string_get (uri, (glong) 2));
#line 1247 "urlbar.c"
	} else {
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp10_ = FALSE;
#line 1251 "urlbar.c"
	}
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp10_) {
#line 242 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp9_ = g_ascii_isalnum (string_get (uri, (glong) 3));
#line 1257 "urlbar.c"
	} else {
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp9_ = FALSE;
#line 1261 "urlbar.c"
	}
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp9_) {
#line 242 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp8_ = string_get (uri, (glong) 4) == ':';
#line 1267 "urlbar.c"
	} else {
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp8_ = FALSE;
#line 1271 "urlbar.c"
	}
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp8_) {
#line 1275 "urlbar.c"
		gboolean _tmp12_ = FALSE;
#line 243 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		if (string_get (uri, (glong) 5) == ':') {
#line 243 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp12_ = TRUE;
#line 1281 "urlbar.c"
		} else {
#line 243 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp12_ = g_ascii_isalnum (string_get (uri, (glong) 5));
#line 1285 "urlbar.c"
		}
#line 243 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp7_ = _tmp12_;
#line 1289 "urlbar.c"
	} else {
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp7_ = FALSE;
#line 1293 "urlbar.c"
	}
#line 241 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp7_) {
#line 244 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		result = TRUE;
#line 244 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		return result;
#line 1301 "urlbar.c"
	}
#line 245 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = FALSE;
#line 245 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1307 "urlbar.c"
}

static gboolean
midori_urlbar_real_focus_out_event (GtkWidget* base,
                                    GdkEventFocus* event)
{
	MidoriUrlbar * self;
	gboolean result = FALSE;
#line 248 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self = (MidoriUrlbar*) base;
#line 249 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_popdown (self);
#line 250 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = GTK_WIDGET_CLASS (midori_urlbar_parent_class)->focus_out_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_entry_get_type (), GtkEntry), event);
#line 250 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1324 "urlbar.c"
}

void
midori_urlbar_popdown (MidoriUrlbar* self)
{
	GtkPopover* _tmp0_;
#line 255 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->suggestions;
#line 255 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp0_ != NULL) {
#line 1335 "urlbar.c"
		GtkPopover* _tmp1_;
#line 256 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = self->priv->suggestions;
#line 256 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 1341 "urlbar.c"
	}
}

static void
midori_urlbar_resize (MidoriUrlbar* self,
                      GtkAllocation* allocation)
{
	gint width = 0;
	GtkWidget* _tmp0_;
	gint _tmp1_ = 0;
	GtkListBox* _tmp2_;
#line 263 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 263 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_window_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_window_get_type (), GtkWindow), &_tmp1_, NULL);
#line 263 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	width = _tmp1_;
#line 264 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	width = (gint) (width / 1.5);
#line 265 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = self->priv->listbox;
#line 265 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp2_, width, -1);
#line 1365 "urlbar.c"
}

static GtkWidget*
_midori_urlbar_create_row_gtk_list_box_create_widget_func (GObject* item,
                                                           gpointer self)
{
	GtkWidget* result;
	result = midori_urlbar_create_row ((MidoriUrlbar*) self, item);
#line 274 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1376 "urlbar.c"
}

static void
midori_urlbar_complete (MidoriUrlbar* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkPopover* _tmp16_;
	GtkPopover* _tmp17_;
	GtkPopover* _tmp18_;
#line 269 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->suggestions;
#line 269 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 269 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = _tmp1_;
#line 269 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (!_tmp2_) {
#line 1396 "urlbar.c"
		GtkPopover* _tmp3_;
		GtkPopover* _tmp4_;
		MidoriCompletion* completion = NULL;
		GtkWidget* _tmp5_;
		MidoriTab* _tmp6_;
		MidoriTab* _tmp7_;
		WebKitWebContext* _tmp8_;
		WebKitWebContext* _tmp9_;
		WebKitWebContext* _tmp10_;
		MidoriCompletion* _tmp11_;
		MidoriCompletion* _tmp12_;
		MidoriCompletion* _tmp13_;
		GtkListBox* _tmp14_;
		MidoriCompletion* _tmp15_;
#line 270 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = self->priv->suggestions;
#line 270 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_popover_set_default_widget (_tmp3_, (GtkWidget*) self);
#line 271 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = self->priv->suggestions;
#line 271 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_popover_set_relative_to (_tmp4_, (GtkWidget*) self);
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp5_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp6_ = midori_browser_get_tab (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, MIDORI_TYPE_BROWSER, MidoriBrowser));
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp7_ = _tmp6_;
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_get ((WebKitWebView*) _tmp7_, "web-context", &_tmp8_, NULL);
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp9_ = _tmp8_;
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp10_ = _tmp9_;
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp11_ = midori_completion_new (webkit_web_context_is_ephemeral (_tmp10_));
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp12_ = _tmp11_;
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (_tmp10_);
#line 272 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		completion = _tmp12_;
#line 273 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp13_ = completion;
#line 273 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_bind_property_with_closures ((GObject*) self, "key", (GObject*) _tmp13_, "key", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 274 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp14_ = self->priv->listbox;
#line 274 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp15_ = completion;
#line 274 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_list_box_bind_model (_tmp14_, (GListModel*) _tmp15_, _midori_urlbar_create_row_gtk_list_box_create_widget_func, g_object_ref (self), g_object_unref);
#line 269 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (completion);
#line 1451 "urlbar.c"
	}
#line 276 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp16_ = self->priv->suggestions;
#line 276 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp16_);
#line 277 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp17_ = self->priv->suggestions;
#line 277 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_grab_add ((GtkWidget*) _tmp17_);
#line 278 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp18_ = self->priv->suggestions;
#line 278 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp18_);
#line 1465 "urlbar.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return _data23_;
#line 1475 "urlbar.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 1485 "urlbar.c"
		MidoriUrlbar* self;
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		self = _data23_->self;
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_free0 (_data23_->text);
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (self);
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_slice_free (Block23Data, _data23_);
#line 1495 "urlbar.c"
	}
}

static void
__lambda30_ (Block23Data* _data23_)
{
	MidoriUrlbar* self;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
#line 285 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self = _data23_->self;
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = midori_urlbar_magic_uri (self, _data23_->text);
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = _tmp1_;
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp0_ == NULL) {
#line 1513 "urlbar.c"
		MidoriCoreSettings* _tmp2_;
		MidoriCoreSettings* _tmp3_;
		gchar* _tmp4_;
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = midori_core_settings_get_default ();
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = _tmp2_;
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = midori_core_settings_uri_for_search (_tmp3_, _data23_->text, NULL);
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_free0 (_tmp0_);
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = _tmp4_;
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (_tmp3_);
#line 1529 "urlbar.c"
	}
#line 286 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_set_uri (self, _tmp0_);
#line 285 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_free0 (_tmp0_);
#line 1535 "urlbar.c"
}

static void
___lambda30__gtk_menu_item_activate (GtkMenuItem* _sender,
                                     gpointer self)
{
#line 285 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	__lambda30_ (self);
#line 1544 "urlbar.c"
}

static void
midori_urlbar_real_populate_popup (GtkEntry* base,
                                   GtkMenu* menu)
{
	MidoriUrlbar * self;
	Block23Data* _data23_;
	GdkDisplay* _tmp0_;
	GtkClipboard* _tmp1_;
	gchar* _tmp2_;
	GtkMenuItem* menuitem = NULL;
	GtkMenuItem* _tmp3_;
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self = (MidoriUrlbar*) base;
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_data23_->_ref_count_ = 1;
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_data23_->self = g_object_ref (self);
#line 282 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 282 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = gtk_clipboard_get_for_display (_tmp0_, GDK_SELECTION_CLIPBOARD);
#line 282 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = gtk_clipboard_wait_for_text (_tmp1_);
#line 282 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_data23_->text = _tmp2_;
#line 283 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp3_ = (GtkMenuItem*) gtk_menu_item_new_with_mnemonic ("Paste and p_roceed");
#line 283 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_ref_sink (_tmp3_);
#line 283 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	menuitem = _tmp3_;
#line 284 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_set_sensitive ((GtkWidget*) menuitem, _data23_->text != NULL);
#line 285 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_data (menuitem, "activate", (GCallback) ___lambda30__gtk_menu_item_activate, block23_data_ref (_data23_), (GClosureNotify) block23_data_unref, 0);
#line 288 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_show ((GtkWidget*) menuitem);
#line 289 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_menu_shell_insert ((GtkMenuShell*) menu, (GtkWidget*) menuitem, 3);
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (menuitem);
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	block23_data_unref (_data23_);
#line 281 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_data23_ = NULL;
#line 1594 "urlbar.c"
}

static void
midori_urlbar_update_icon (MidoriUrlbar* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp5_;
	gboolean _tmp6_;
#line 293 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = midori_urlbar_get_blank (self);
#line 293 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = _tmp0_;
#line 293 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp1_) {
#line 294 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_set ((GtkEntry*) self, "primary-icon-name", NULL, NULL);
#line 1612 "urlbar.c"
	} else {
		const gchar* _tmp2_ = NULL;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 296 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = midori_urlbar_get_secure (self);
#line 296 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = _tmp3_;
#line 296 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		if (_tmp4_) {
#line 296 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp2_ = "channel-secure-symbolic";
#line 1625 "urlbar.c"
		} else {
#line 296 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
			_tmp2_ = "channel-insecure-symbolic";
#line 1629 "urlbar.c"
		}
#line 296 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_set ((GtkEntry*) self, "primary-icon-name", _tmp2_, NULL);
#line 1633 "urlbar.c"
	}
#line 298 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp5_ = midori_urlbar_get_blank (self);
#line 298 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp6_ = _tmp5_;
#line 298 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_set ((GtkEntry*) self, "primary-icon-activatable", !_tmp6_, NULL);
#line 1641 "urlbar.c"
}

static gboolean
___lambda31_ (MidoriUrlbar* self,
              GdkEventButton* event)
{
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkWidget* _tmp3_;
	gboolean result = FALSE;
#line 312 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = gtk_get_event_widget ((GdkEvent*) event);
#line 312 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 312 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	widget = _tmp1_;
#line 313 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp3_ = widget;
#line 313 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp3_ != G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget)) {
#line 1664 "urlbar.c"
		GtkWidget* _tmp4_;
		GtkPopover* _tmp5_;
#line 313 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = widget;
#line 313 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp5_ = self->priv->security;
#line 313 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = !gtk_widget_is_ancestor (_tmp4_, (GtkWidget*) _tmp5_);
#line 1673 "urlbar.c"
	} else {
#line 313 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp2_ = FALSE;
#line 1677 "urlbar.c"
	}
#line 313 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp2_) {
#line 1681 "urlbar.c"
		GtkPopover* _tmp6_;
#line 314 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp6_ = self->priv->security;
#line 314 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_widget_hide ((GtkWidget*) _tmp6_);
#line 1687 "urlbar.c"
	}
#line 316 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = TRUE;
#line 316 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (widget);
#line 316 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1695 "urlbar.c"
}

static gboolean
____lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                             GdkEventButton* event,
                                             gpointer self)
{
	gboolean result;
	result = ___lambda31_ ((MidoriUrlbar*) self, event);
#line 311 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 1707 "urlbar.c"
}

static void
_vala_SoupURI_free (SoupURI* self)
{
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_boxed_free (soup_uri_get_type (), self);
#line 1715 "urlbar.c"
}

static void
___lambda32_ (MidoriUrlbar* self)
{
	MidoriTab* tab = NULL;
	GtkWidget* _tmp0_;
	MidoriTab* _tmp1_;
	MidoriTab* _tmp2_;
	MidoriTab* _tmp3_;
	WebKitWebContext* _tmp4_;
	WebKitWebContext* _tmp5_;
	WebKitWebContext* _tmp6_;
	GTlsCertificate* _tmp7_;
	GTlsCertificate* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	SoupURI* _tmp11_;
	SoupURI* _tmp12_;
	const gchar* _tmp13_;
	GtkPopover* _tmp14_;
#line 319 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 319 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = midori_browser_get_tab (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, MIDORI_TYPE_BROWSER, MidoriBrowser));
#line 319 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = _tmp1_;
#line 319 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 319 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	tab = _tmp3_;
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_get ((WebKitWebView*) tab, "web-context", &_tmp4_, NULL);
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp5_ = _tmp4_;
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp6_ = _tmp5_;
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp7_ = midori_tab_get_tls (tab);
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp8_ = _tmp7_;
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp9_ = midori_urlbar_get_uri (self);
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp10_ = _tmp9_;
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp11_ = soup_uri_new (_tmp10_);
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp12_ = _tmp11_;
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp13_ = _tmp12_->host;
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	webkit_web_context_allow_tls_certificate_for_host (_tmp6_, _tmp8_, _tmp13_);
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	__vala_SoupURI_free0 (_tmp12_);
#line 320 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (_tmp6_);
#line 321 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp14_ = self->priv->security;
#line 321 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_hide ((GtkWidget*) _tmp14_);
#line 322 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	webkit_web_view_reload ((WebKitWebView*) tab);
#line 318 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (tab);
#line 1781 "urlbar.c"
}

static void
____lambda32__gtk_button_clicked (GtkButton* _sender,
                                  gpointer self)
{
#line 318 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	___lambda32_ ((MidoriUrlbar*) self);
#line 1790 "urlbar.c"
}

static void
midori_urlbar_icon_pressed (MidoriUrlbar* self,
                            GtkEntryIconPosition position,
                            GdkEvent* event)
{
	GTlsCertificate* tls = NULL;
	GtkWidget* _tmp0_;
	MidoriTab* _tmp1_;
	MidoriTab* _tmp2_;
	GTlsCertificate* _tmp3_;
	GTlsCertificate* _tmp4_;
	GTlsCertificate* _tmp5_;
	GcrSimpleCertificate* _tmp6_ = NULL;
	GTlsCertificate* _tmp7_;
	GcrSimpleCertificate* certificate = NULL;
	GcrSimpleCertificate* _tmp14_;
	GcrCertificateWidget* _tmp15_;
	GcrCertificateWidget* _tmp25_;
	GTlsCertificate* _tmp26_;
	gboolean _tmp27_ = FALSE;
	GTlsCertificate* _tmp28_;
	GtkButton* _tmp31_;
	GcrCertificateWidget* _tmp32_;
	GcrSimpleCertificate* _tmp33_;
	GtkLabel* _tmp34_;
	gboolean _tmp35_;
	gboolean _tmp36_;
	GtkPopover* _tmp37_;
#line 302 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = gtk_widget_get_toplevel ((GtkWidget*) self);
#line 302 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = midori_browser_get_tab (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, MIDORI_TYPE_BROWSER, MidoriBrowser));
#line 302 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = _tmp1_;
#line 302 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp3_ = midori_tab_get_tls (_tmp2_);
#line 302 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp4_ = _tmp3_;
#line 302 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 302 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	tls = _tmp5_;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp7_ = tls;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp7_ != NULL) {
#line 1839 "urlbar.c"
		GTlsCertificate* _tmp8_;
		GByteArray* _tmp9_;
		GByteArray* _tmp10_;
		GByteArray* _tmp11_;
		guint8* _tmp12_;
		gint _tmp12__length1;
		GcrSimpleCertificate* _tmp13_;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp8_ = tls;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_get (_tmp8_, "certificate", &_tmp9_, NULL);
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp10_ = _tmp9_;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp11_ = _tmp10_;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp12_ = _tmp11_->data;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp12__length1 = _tmp11_->len;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp13_ = (GcrSimpleCertificate*) gcr_simple_certificate_new (_tmp12_, _tmp12__length1);
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (_tmp6_);
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp6_ = _tmp13_;
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_byte_array_unref0 (_tmp11_);
#line 1867 "urlbar.c"
	} else {
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (_tmp6_);
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp6_ = NULL;
#line 1873 "urlbar.c"
	}
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp14_ = _g_object_ref0 (_tmp6_);
#line 303 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	certificate = _tmp14_;
#line 304 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp15_ = self->priv->details;
#line 304 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp15_ == NULL) {
#line 1883 "urlbar.c"
		GdkRectangle icon_area = {0};
		GdkRectangle _tmp16_ = {0};
		GtkPopover* _tmp17_;
		GtkPopover* _tmp18_;
		GdkRectangle _tmp19_;
		GtkPopover* _tmp20_;
		GtkButton* _tmp21_;
		GcrCertificateWidget* _tmp22_;
		GtkBox* _tmp23_;
		GcrCertificateWidget* _tmp24_;
#line 305 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_entry_get_icon_area ((GtkEntry*) self, position, &_tmp16_);
#line 305 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		icon_area = _tmp16_;
#line 306 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp17_ = self->priv->security;
#line 306 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_popover_set_relative_to (_tmp17_, (GtkWidget*) self);
#line 307 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp18_ = self->priv->security;
#line 307 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp19_ = icon_area;
#line 307 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_set (_tmp18_, "pointing-to", &_tmp19_, NULL);
#line 311 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp20_ = self->priv->security;
#line 311 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_signal_connect_object ((GtkWidget*) _tmp20_, "button-press-event", (GCallback) ____lambda31__gtk_widget_button_press_event, self, 0);
#line 318 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp21_ = self->priv->trust;
#line 318 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_signal_connect_object (_tmp21_, "clicked", (GCallback) ____lambda32__gtk_button_clicked, self, 0);
#line 326 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp22_ = gcr_certificate_widget_new (NULL);
#line 326 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_ref_sink (_tmp22_);
#line 326 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_object_unref0 (self->priv->details);
#line 326 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		self->priv->details = _tmp22_;
#line 327 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp23_ = self->priv->security_box;
#line 327 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp24_ = self->priv->details;
#line 327 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		gtk_container_add ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 1930 "urlbar.c"
	}
#line 329 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp25_ = self->priv->details;
#line 329 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp26_ = tls;
#line 329 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp25_, _tmp26_ != NULL);
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp28_ = tls;
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp28_ != NULL) {
#line 1942 "urlbar.c"
		gboolean _tmp29_;
		gboolean _tmp30_;
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp29_ = midori_urlbar_get_secure (self);
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp30_ = _tmp29_;
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp27_ = !_tmp30_;
#line 1951 "urlbar.c"
	} else {
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp27_ = FALSE;
#line 1955 "urlbar.c"
	}
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp31_ = self->priv->trust;
#line 330 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp31_, _tmp27_);
#line 331 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp32_ = self->priv->details;
#line 331 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp33_ = certificate;
#line 331 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gcr_certificate_widget_set_certificate (_tmp32_, (GcrCertificate*) _tmp33_);
#line 332 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp34_ = self->priv->security_status;
#line 332 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp35_ = midori_urlbar_get_secure (self);
#line 332 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp36_ = _tmp35_;
#line 332 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp34_, !_tmp36_);
#line 333 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp37_ = self->priv->security;
#line 333 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_show ((GtkWidget*) _tmp37_);
#line 301 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (certificate);
#line 301 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (_tmp6_);
#line 301 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (tls);
#line 1985 "urlbar.c"
}

MidoriUrlbar*
midori_urlbar_construct (GType object_type)
{
	MidoriUrlbar * self = NULL;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self = (MidoriUrlbar*) g_object_new (object_type, NULL);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return self;
#line 1996 "urlbar.c"
}

MidoriUrlbar*
midori_urlbar_new (void)
{
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return midori_urlbar_construct (MIDORI_TYPE_URLBAR);
#line 2004 "urlbar.c"
}

const gchar*
midori_urlbar_get_key (MidoriUrlbar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->_key;
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp0_;
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 2018 "urlbar.c"
}

void
midori_urlbar_set_key (MidoriUrlbar* self,
                       const gchar* value)
{
	gchar* old_value;
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	old_value = midori_urlbar_get_key (self);
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2030 "urlbar.c"
		gchar* _tmp0_;
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = g_strdup (value);
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_free0 (self->priv->_key);
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		self->priv->_key = _tmp0_;
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_notify_by_pspec ((GObject *) self, midori_urlbar_properties[MIDORI_URLBAR_KEY_PROPERTY]);
#line 2040 "urlbar.c"
	}
}

GRegex*
midori_urlbar_get_regex (MidoriUrlbar* self)
{
	GRegex* result;
	GRegex* _tmp0_;
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->_regex;
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp0_;
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 2055 "urlbar.c"
}

static gpointer
_g_regex_ref0 (gpointer self)
{
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return self ? g_regex_ref (self) : NULL;
#line 2063 "urlbar.c"
}

void
midori_urlbar_set_regex (MidoriUrlbar* self,
                         GRegex* value)
{
	GRegex* old_value;
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	old_value = midori_urlbar_get_regex (self);
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (old_value != value) {
#line 2075 "urlbar.c"
		GRegex* _tmp0_;
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = _g_regex_ref0 (value);
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_regex_unref0 (self->priv->_regex);
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		self->priv->_regex = _tmp0_;
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_notify_by_pspec ((GObject *) self, midori_urlbar_properties[MIDORI_URLBAR_REGEX_PROPERTY]);
#line 2085 "urlbar.c"
	}
}

const gchar*
midori_urlbar_get_location (MidoriUrlbar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->_location;
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp0_;
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 2100 "urlbar.c"
}

void
midori_urlbar_set_location (MidoriUrlbar* self,
                            const gchar* value)
{
	gchar* old_value;
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	old_value = midori_urlbar_get_location (self);
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2112 "urlbar.c"
		gchar* _tmp0_;
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = g_strdup (value);
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_g_free0 (self->priv->_location);
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		self->priv->_location = _tmp0_;
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_object_notify_by_pspec ((GObject *) self, midori_urlbar_properties[MIDORI_URLBAR_LOCATION_PROPERTY]);
#line 2122 "urlbar.c"
	}
}

const gchar*
midori_urlbar_get_uri (MidoriUrlbar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 20 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->_uri;
#line 20 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp0_;
#line 20 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 2137 "urlbar.c"
}

void
midori_urlbar_set_uri (MidoriUrlbar* self,
                       const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 22 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = g_strdup (value);
#line 22 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_free0 (self->priv->_uri);
#line 22 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self->priv->_uri = _tmp0_;
#line 23 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_set_location (self, value);
#line 25 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = midori_urlbar_get_blank (self);
#line 25 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp3_ = _tmp2_;
#line 25 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (_tmp3_) {
#line 25 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = "";
#line 2164 "urlbar.c"
	} else {
#line 25 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp1_ = value;
#line 2168 "urlbar.c"
	}
#line 25 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_entry_set_text ((GtkEntry*) self, _tmp1_);
#line 26 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_editable_set_position ((GtkEditable*) self, -1);
#line 27 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_update_icon (self);
#line 21 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_notify_by_pspec ((GObject *) self, midori_urlbar_properties[MIDORI_URLBAR_URI_PROPERTY]);
#line 2178 "urlbar.c"
}

gboolean
midori_urlbar_get_secure (MidoriUrlbar* self)
{
	gboolean result;
#line 30 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = self->priv->_secure;
#line 30 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 2189 "urlbar.c"
}

void
midori_urlbar_set_secure (MidoriUrlbar* self,
                          gboolean value)
{
#line 31 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self->priv->_secure = value;
#line 32 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_update_icon (self);
#line 30 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_notify_by_pspec ((GObject *) self, midori_urlbar_properties[MIDORI_URLBAR_SECURE_PROPERTY]);
#line 2202 "urlbar.c"
}

gboolean
midori_urlbar_get_blank (MidoriUrlbar* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = midori_urlbar_get_uri (self);
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = _tmp1_;
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	if (g_strcmp0 (_tmp2_, "about:blank") == 0) {
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = TRUE;
#line 2220 "urlbar.c"
	} else {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp3_ = midori_urlbar_get_uri (self);
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp4_ = _tmp3_;
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "internal:speed-dial") == 0;
#line 2230 "urlbar.c"
	}
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 2236 "urlbar.c"
}

static GtkListBoxRow*
midori_urlbar_get_selected_row (MidoriUrlbar* self)
{
	GtkListBoxRow* result;
	GtkListBoxRow* _tmp0_;
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->_selected_row;
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	result = _tmp0_;
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return result;
#line 2250 "urlbar.c"
}

static void
midori_urlbar_set_selected_row (MidoriUrlbar* self,
                                GtkListBoxRow* value)
{
	GtkListBoxRow* _tmp0_;
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (self->priv->_selected_row);
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self->priv->_selected_row = _tmp0_;
#line 2264 "urlbar.c"
}

static void
_midori_urlbar_resize_gtk_widget_size_allocate (GtkWidget* _sender,
                                                GtkAllocation* allocation,
                                                gpointer self)
{
#line 52 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_resize ((MidoriUrlbar*) self, allocation);
#line 2274 "urlbar.c"
}

static void
_midori_urlbar___lambda33_ (MidoriUrlbar* self)
{
	GtkPopover* _tmp0_;
#line 54 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->suggestions;
#line 54 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_grab_remove ((GtkWidget*) _tmp0_);
#line 2285 "urlbar.c"
}

static void
__midori_urlbar___lambda33__gtk_widget_hide (GtkWidget* _sender,
                                             gpointer self)
{
#line 53 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_midori_urlbar___lambda33_ ((MidoriUrlbar*) self);
#line 2294 "urlbar.c"
}

static void
_midori_urlbar___lambda34_ (MidoriUrlbar* self,
                            GtkListBoxRow* row)
{
#line 58 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_set_selected_row (self, row);
#line 2303 "urlbar.c"
}

static void
__midori_urlbar___lambda34__gtk_list_box_row_selected (GtkListBox* _sender,
                                                       GtkListBoxRow* row,
                                                       gpointer self)
{
#line 57 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_midori_urlbar___lambda34_ ((MidoriUrlbar*) self, row);
#line 2313 "urlbar.c"
}

static void
_midori_urlbar___lambda35_ (MidoriUrlbar* self,
                            GtkListBoxRow* row)
{
	MidoriSuggestionRow* suggestion = NULL;
	MidoriSuggestionRow* _tmp0_;
	MidoriSuggestionRow* _tmp1_;
	MidoriDatabaseItem* _tmp2_;
	MidoriDatabaseItem* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 61 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_popdown (self);
#line 62 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row, MIDORI_TYPE_SUGGESTION_ROW, MidoriSuggestionRow));
#line 62 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	suggestion = _tmp0_;
#line 63 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = suggestion;
#line 63 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = midori_suggestion_row_get_item (_tmp1_);
#line 63 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp3_ = _tmp2_;
#line 63 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp4_ = midori_database_item_get_uri (_tmp3_);
#line 63 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp5_ = _tmp4_;
#line 63 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_set_uri (self, _tmp5_);
#line 60 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (suggestion);
#line 2347 "urlbar.c"
}

static void
__midori_urlbar___lambda35__gtk_list_box_row_activated (GtkListBox* _sender,
                                                        GtkListBoxRow* row,
                                                        gpointer self)
{
#line 60 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_midori_urlbar___lambda35_ ((MidoriUrlbar*) self, row);
#line 2357 "urlbar.c"
}

static void
_midori_urlbar___lambda36_ (MidoriUrlbar* self,
                            const gchar* new_text,
                            gint new_position,
                            gint* position)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 67 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = gtk_entry_get_text ((GtkEntry*) self);
#line 67 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = _tmp0_;
#line 67 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_update_key (self, _tmp1_);
#line 2374 "urlbar.c"
}

static void
__midori_urlbar___lambda36__gtk_editable_insert_text (GtkEditable* _sender,
                                                      const gchar* new_text,
                                                      gint new_text_length,
                                                      gint* position,
                                                      gpointer self)
{
#line 66 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_midori_urlbar___lambda36_ ((MidoriUrlbar*) self, new_text, new_text_length, position);
#line 2386 "urlbar.c"
}

static void
_midori_urlbar___lambda37_ (MidoriUrlbar* self,
                            gint start_pos,
                            gint end_pos)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 70 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = gtk_entry_get_text ((GtkEntry*) self);
#line 70 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = _tmp0_;
#line 70 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_update_key (self, _tmp1_);
#line 2402 "urlbar.c"
}

static void
__midori_urlbar___lambda37__gtk_editable_delete_text (GtkEditable* _sender,
                                                      gint start_pos,
                                                      gint end_pos,
                                                      gpointer self)
{
#line 69 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_midori_urlbar___lambda37_ ((MidoriUrlbar*) self, start_pos, end_pos);
#line 2413 "urlbar.c"
}

static void
_midori_urlbar_icon_pressed_gtk_entry_icon_press (GtkEntry* _sender,
                                                  GtkEntryIconPosition icon_pos,
                                                  GdkEvent* event,
                                                  gpointer self)
{
#line 72 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_icon_pressed ((MidoriUrlbar*) self, icon_pos, event);
#line 2424 "urlbar.c"
}

static GObject *
midori_urlbar_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MidoriUrlbar * self;
	GtkPopover* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
#line 51 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	parent_class = G_OBJECT_CLASS (midori_urlbar_parent_class);
#line 51 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 51 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_URLBAR, MidoriUrlbar);
#line 52 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) _midori_urlbar_resize_gtk_widget_size_allocate, self, 0);
#line 53 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp0_ = self->priv->suggestions;
#line 53 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_object ((GtkWidget*) _tmp0_, "hide", (GCallback) __midori_urlbar___lambda33__gtk_widget_hide, self, 0);
#line 57 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp1_ = self->priv->listbox;
#line 57 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_object (_tmp1_, "row-selected", (GCallback) __midori_urlbar___lambda34__gtk_list_box_row_selected, self, 0);
#line 60 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_tmp2_ = self->priv->listbox;
#line 60 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_object (_tmp2_, "row-activated", (GCallback) __midori_urlbar___lambda35__gtk_list_box_row_activated, self, 0);
#line 66 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_object ((GtkEditable*) self, "insert-text", (GCallback) __midori_urlbar___lambda36__gtk_editable_insert_text, self, G_CONNECT_AFTER);
#line 69 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_object ((GtkEditable*) self, "delete-text", (GCallback) __midori_urlbar___lambda37__gtk_editable_delete_text, self, G_CONNECT_AFTER);
#line 72 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_signal_connect_object ((GtkEntry*) self, "icon-press", (GCallback) _midori_urlbar_icon_pressed_gtk_entry_icon_press, self, 0);
#line 51 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	return obj;
#line 2466 "urlbar.c"
}

static void
midori_urlbar_class_init (MidoriUrlbarClass * klass,
                          gpointer klass_data)
{
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	midori_urlbar_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_type_class_adjust_private_offset (klass, &MidoriUrlbar_private_offset);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) midori_urlbar_real_key_press_event;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	((GtkWidgetClass *) klass)->focus_out_event = (gboolean (*) (GtkWidget*, GdkEventFocus*)) midori_urlbar_real_focus_out_event;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	((GtkEntryClass *) klass)->populate_popup = (void (*) (GtkEntry*, GtkMenu*)) midori_urlbar_real_populate_popup;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_midori_urlbar_get_property;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_midori_urlbar_set_property;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	G_OBJECT_CLASS (klass)->constructor = midori_urlbar_constructor;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	G_OBJECT_CLASS (klass)->finalize = midori_urlbar_finalize;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_URLBAR_KEY_PROPERTY, midori_urlbar_properties[MIDORI_URLBAR_KEY_PROPERTY] = g_param_spec_string ("key", "key", "key", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_URLBAR_REGEX_PROPERTY, midori_urlbar_properties[MIDORI_URLBAR_REGEX_PROPERTY] = g_param_spec_boxed ("regex", "regex", "regex", G_TYPE_REGEX, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_URLBAR_LOCATION_PROPERTY, midori_urlbar_properties[MIDORI_URLBAR_LOCATION_PROPERTY] = g_param_spec_string ("location", "location", "location", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_URLBAR_URI_PROPERTY, midori_urlbar_properties[MIDORI_URLBAR_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_URLBAR_SECURE_PROPERTY, midori_urlbar_properties[MIDORI_URLBAR_SECURE_PROPERTY] = g_param_spec_boolean ("secure", "secure", "secure", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MIDORI_URLBAR_BLANK_PROPERTY, midori_urlbar_properties[MIDORI_URLBAR_BLANK_PROPERTY] = g_param_spec_boolean ("blank", "blank", "blank", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ui/urlbar.ui");
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "suggestions", FALSE, MidoriUrlbar_private_offset + G_STRUCT_OFFSET (MidoriUrlbarPrivate, suggestions));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "listbox", FALSE, MidoriUrlbar_private_offset + G_STRUCT_OFFSET (MidoriUrlbarPrivate, listbox));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "security", FALSE, MidoriUrlbar_private_offset + G_STRUCT_OFFSET (MidoriUrlbarPrivate, security));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "security_box", FALSE, MidoriUrlbar_private_offset + G_STRUCT_OFFSET (MidoriUrlbarPrivate, security_box));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "trust", FALSE, MidoriUrlbar_private_offset + G_STRUCT_OFFSET (MidoriUrlbarPrivate, trust));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "security_status", FALSE, MidoriUrlbar_private_offset + G_STRUCT_OFFSET (MidoriUrlbarPrivate, security_status));
#line 2517 "urlbar.c"
}

static void
midori_urlbar_instance_init (MidoriUrlbar * self,
                             gpointer klass)
{
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self->priv = midori_urlbar_get_instance_private (self);
#line 29 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self->priv->_secure = FALSE;
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self->priv->_selected_row = NULL;
#line 49 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self->priv->details = NULL;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2534 "urlbar.c"
}

static void
midori_urlbar_finalize (GObject * obj)
{
	MidoriUrlbar * self;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MIDORI_TYPE_URLBAR, MidoriUrlbar);
#line 15 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_free0 (self->priv->_key);
#line 16 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_regex_unref0 (self->priv->_regex);
#line 17 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_free0 (self->priv->_location);
#line 18 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_free0 (self->priv->_uri);
#line 40 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (self->priv->_selected_row);
#line 49 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	_g_object_unref0 (self->priv->details);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	G_OBJECT_CLASS (midori_urlbar_parent_class)->finalize (obj);
#line 2557 "urlbar.c"
}

static GType
midori_urlbar_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MidoriUrlbarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_urlbar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriUrlbar), 0, (GInstanceInitFunc) midori_urlbar_instance_init, NULL };
	GType midori_urlbar_type_id;
	midori_urlbar_type_id = g_type_register_static (gtk_entry_get_type (), "MidoriUrlbar", &g_define_type_info, 0);
	MidoriUrlbar_private_offset = g_type_add_instance_private (midori_urlbar_type_id, sizeof (MidoriUrlbarPrivate));
	return midori_urlbar_type_id;
}

GType
midori_urlbar_get_type (void)
{
	static volatile gsize midori_urlbar_type_id__volatile = 0;
	if (g_once_init_enter (&midori_urlbar_type_id__volatile)) {
		GType midori_urlbar_type_id;
		midori_urlbar_type_id = midori_urlbar_get_type_once ();
		g_once_init_leave (&midori_urlbar_type_id__volatile, midori_urlbar_type_id);
	}
	return midori_urlbar_type_id__volatile;
}

static void
_vala_midori_urlbar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	MidoriUrlbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_URLBAR, MidoriUrlbar);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_KEY_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_value_set_string (value, midori_urlbar_get_key (self));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_REGEX_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_value_set_boxed (value, midori_urlbar_get_regex (self));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_LOCATION_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_value_set_string (value, midori_urlbar_get_location (self));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_URI_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_value_set_string (value, midori_urlbar_get_uri (self));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_SECURE_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_value_set_boolean (value, midori_urlbar_get_secure (self));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_BLANK_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		g_value_set_boolean (value, midori_urlbar_get_blank (self));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 2628 "urlbar.c"
		default:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 2634 "urlbar.c"
	}
}

static void
_vala_midori_urlbar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	MidoriUrlbar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, MIDORI_TYPE_URLBAR, MidoriUrlbar);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
	switch (property_id) {
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_KEY_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_key (self, g_value_get_string (value));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_REGEX_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_regex (self, g_value_get_boxed (value));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_LOCATION_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_location (self, g_value_get_string (value));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_URI_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_uri (self, g_value_get_string (value));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		case MIDORI_URLBAR_SECURE_PROPERTY:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		midori_urlbar_set_secure (self, g_value_get_boolean (value));
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 2678 "urlbar.c"
		default:
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "/builddir/build/BUILD/midori-v9.0/core/urlbar.vala"
		break;
#line 2684 "urlbar.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

